/*
 *	pme001.h
 *
 *	P/ECE Linux device driver
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Tue Jan  1 08:50:04 JST 2002 Naoyuki Sawa
 *	- ϡ
 */
#ifndef __PME001_H__
#define __PME001_H__

/* P/ECEƥ */
typedef struct _PME001SYSTEMINFO {
	unsigned short size;		/*  0: ι¤ΤΥ */
	unsigned short hard_ver;	/*  2: ϡɥС */
	unsigned short bios_ver;	/*  4: BIOSС */
	unsigned short bios_date;	/*  6: BIOS YY(7):MM(4):DD(5) */
	unsigned long sys_clock;	/*  8: ƥࡦå(Hz) */
	unsigned short vdde_voltage;	/* 12: VDDE()Ű(mV) */
	unsigned short resv1;		/* 14: ͽ */
	unsigned char *sram_top;	/* 16: SRAM ϥɥ쥹 */
	unsigned char *sram_end;	/* 20: SRAM λɥ쥹+1 */
	unsigned char *pffs_top;	/* 24: pffs ϥɥ쥹 */
	unsigned char *pffs_end;	/* 28: pffs λɥ쥹 */
} PME001SYSTEMINFO;

/* USBCOM̿ */
typedef struct _PME001USBCOMS {
	unsigned char rxstat;		/*  0:  */
	unsigned char txstat;		/*  1:  */
	unsigned char pistat;		/*  2: PIECE Υץե饰 */
	unsigned char mystat;		/*  3: PC Υץե饰 */
	unsigned long rxlen;		/*  4: ׵᥵ */
	unsigned long txlen;		/*  8: ׵᥵ */
	char signature[16];		/* 12: ȹʸ */
} PME001USBCOMS;
/* rxstat */
#define UCS_RXWAIT	1	/* Ե */
#define UCS_RXING	2	/*  */
#define UCS_RXDONE	4	/* λ */
/* txstat */
#define UCS_TXWAIT	1	/* Ե */
#define UCS_TXING	2	/*  */
#define UCS_TXDONE	4	/* λ */

/* ioctlѥ᡼ */
typedef struct _PME001READMEM {
	unsigned char* ptr;
	unsigned long adrs;
	unsigned long len;
} PME001READMEM;
typedef struct _PME001WRITEMEM {
	const unsigned char* ptr;
	unsigned long adrs;
	unsigned long len;
} PME001WRITEMEM;
typedef struct _PME001UCREAD {
	void* ptr;
	unsigned long len;
} PME001UCREAD;
typedef struct _PME001UCWRITE {
	const void* ptr;
	unsigned long len;
} PME001UCWRITE;

/* ioctlޥ */
#define PME001_IOC_MAGIC	'p'
#define PME001_IOC_GETVERSION	_IOR(PME001_IOC_MAGIC, 0, PME001SYSTEMINFO)
#define PME001_IOC_EXEC		_IO(PME001_IOC_MAGIC, 1)
#define PME001_IOC_READMEM	_IOW(PME001_IOC_MAGIC, 2, PME001READMEM)
#define PME001_IOC_WRITEMEM	_IOW(PME001_IOC_MAGIC, 3, PME001WRITEMEM)
#if 0
#define PME001_IOC_SETAPPSTAT	4
#define PME001_IOC_GETAPPSTAT	5
#define PME001_IOC_GETWAVESTAT	6
#define PME001_IOC_OUTWAVEDATA	7
#define PME001_IOC_FLASHERASE	8
#define PME001_IOC_FLASHWRITE	9
#endif
#define PME001_IOC_UCREAD	_IOW(PME001_IOC_MAGIC, 10, PME001UCREAD)
#define PME001_IOC_UCWRITE	_IOW(PME001_IOC_MAGIC, 11, PME001UCWRITE)
#define PME001_IOC_UCGETSTAT	_IOW(PME001_IOC_MAGIC, 12, PME001USBCOMS)
#define PME001_IOC_UCOPEN	_IOW(PME001_IOC_MAGIC, 13, PME001USBCOMS)
#define PME001_IOC_UCCLOSE	_IO(PME001_IOC_MAGIC, 14)
/* isd-level interface */
/* TODO: */
#define PME001_IOC_MAXNR	18

#endif /*__PME001_H__*/

