/*	
 *	clipmisc.h
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Dec 12 21:51:29 JST 2001 Naoyuki Sawa
 *	- ϡ
 */
#include "clipstd.h"
#include "clipmisc.h"

/*****************************************************************************
 *	Хѿ
 *****************************************************************************/

#ifdef PIECE
/* S1C33 Family CѥѥåǤϡ
 * errnoϥץꥱ¦ɬפޤ
 * [S5U1C33000C_J.pdf p.140]
 */
int errno;
#endif /*PIECE*/

/*****************************************************************************
 *	顼
 *****************************************************************************/

void
die(const char* fmt, ...)
{
#ifdef PIECE
	asm("
	xcall pceLCDDispStop		; pceLCDDispStop();
	xld.w %r12, _def_vbuff		; pceLCDSetBuffer(_def_vbuff);
	xcall pceLCDSetBuffer
	xcall pceLCDDispStart		; pceLCDDispStart();
	xld.w %r12, 0			; pceFontSetType(0);
	xcall pceFontSetType
	xld.w %r12, 3			; pceFontSetTxColor(3);
	xcall pceFontSetTxColor
	xld.w %r12, 0			; pceFontSetBkColor(0);
	xcall pceFontSetBkColor
	xld.w %r12, 0			; pceFontSetPos(0, 0);
	xld.w %r13, 0
	xcall pceFontSetPos
	xld.w %r4, die_L10		; pceFontPrintf(fmt, ...);
	xld.w [%sp], %r4
	xjp pceFontPrintf
die_L10:
	xcall pceLCDTrans		; pceFontLCDTrans();
die_L20:				; for(;;) {
	xcall yield			;	yield();
	xcall pcePadGet			;	if(pcePadGet() & TRG_START) {
	xand %r10, %r10, 0x8000		;
	xjreq die_L30			;
	xld.w %r12, 1			;		pceAppReqExit(1);
	xcall pceAppReqExit		;
die_L30:				;	}
	xjp die_L20			; }
	");
#else /*PIECE*/
	va_list ap;
	va_start(ap, fmt);
	fprintf(stderr, fmt, ap);
	fprintf(stderr, "\n");
	va_end(ap);
	abort();
#endif /*PIECE*/
}

/*****************************************************************************
 *	P/ECEѡmainե졼
 *****************************************************************************/
#ifdef PIECE

static void app_proc();
static void app_exit();

/* * ѥ쥸Τ¸ɬפΤϡr0r3ΤߤǤ
 *   [S5U1C33000C_J.pdf p.84]
 */
typedef struct _CONTEXT {
	int r0, r1, r2, r3;
	int* sp;
} CONTEXT;
/* * system_contextuser_contextϡstaticѿȤƤ⤤ΤǤ
 *   Cѥϡasm֥åѿƤ뤳ȤȽǤǤ
 *   "system_contextƤ뤬ȤƤʤ"ȷٹ𤷤ޤ
 *   ϡٹΤˡХѿȤ뤳Ȥˤޤ
 */
CONTEXT system_context;	/* ƥॳƥ¸ */
CONTEXT user_context;	/* 桼ƥ¸ */

void
pceAppInit()
{
	/* 桼ƥȤޤ */
	user_context.sp = (int*)0x1C00;		/* 10001C00:桼å(3KB) */
						/* 1C002000:ƥॹå(1KB) */
	*--user_context.sp = (int)app_exit;	/* main()֤˸ƤФؿ */
	*--user_context.sp = (int)main;		/* ץꥱȥݥ */

#ifdef USB_CAPTURE
	/* PceCapsбɤޤ */
	usbCaptureInit();
#endif /*USB_CAPTURE*/
}

void
pceAppProc(int count)
{
	/* yield()ȥåե졼ι碌ɬפΤǡ
	 * ʤδؿͳޤ
	 */
	app_proc();
}

void
pceAppExit()
{
#ifdef USB_CAPTURE
	/* PceCapsбɤޤ */
	usbCaptureRelease();
#endif /*USB_CAPTURE*/
}

void
app_proc()
{
	asm("
	; ƥॳƥȤ򤷤ޤ
	xld.w %r7, system_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; 桼ƥȤޤ
	xld.w %r7, user_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

static void
app_exit()
{
	asm("
	; ƥॳƥȤޤ
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4

	; λ׵ȯԤޤ
	ld.w %r12, %r10
	xcall pceAppReqExit
	");
}

void
yield()
{
	asm("
	; 桼ƥȤ򤷤ޤ
	xld.w %r7, user_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; ƥॳƥȤޤ
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

#endif /*PIECE*/
