/*	
 *	cliptask.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Fri Nov 30 14:58:56 JST 2001 Naoyuki Sawa
 *	- ϡ
 *	* Fri Nov 30 16:32:28 JST 2001 Naoyuki Sawa
 *	- 1st꡼
 */
#include "clipstd.h"
#include "cliptask.h"

/*****************************************************************************
 *	TASK
 *****************************************************************************/

TASK*
task_new(TASK* parent, int data_size)
{
	TASK *task, *task_pos;

	/* ݤޤ */
	task = (TASK*)calloc(1, sizeof(TASK) + data_size);
	if(task == NULL) return NULL; /*  */

	/* ȥåץ٥륿ǤʤС
	 * ƥؤΥݥ󥿤Ǽ
	 * ƥΥꥹȤɲäޤ
	 */
	if(parent != NULL) {
		task->parent = parent;
		if((task_pos = parent->children) == NULL) {
			parent->children = task;
		} else {
			while(task_pos->siblings != NULL) {
				task_pos = task_pos->siblings;
			}
			task_pos->siblings = task;
		}
	}

	return task;
}

void
task_free(TASK* task)
{
	TASK *parent, *task_pos;

	/* Freeϥɥ餬СƤӽФޤ */
	if(task->free != NULL) task->free(task);

	/* Ƥλҥޤ */
	task_clear(task);

	/* ȥåץ٥륿ǤʤС
	 * ƥΥꥹȤޤ
	 */
	if((parent = task->parent) != NULL) {
		if((task_pos = parent->children) == task) {
			parent->children = task->siblings;
		} else {
			while(task_pos->siblings != task) {
				task_pos = task_pos->siblings;
			}
			task_pos->siblings = task->siblings;
		}
	}

	/* ޤ */
	free(task);
}

void
task_clear(TASK* task)
{
	TASK* task_pos;

	/* ꥹȤˤʤޤǡ
	 * ꥹȤƬޤ
	 */
	while((task_pos = task->children) != NULL) {
		task_free(task_pos);
	}
}

int
task_work(TASK* task)
{
	TASK *task_pos, *task_next;

	/* ڥʤ顢⤻˵ޤ */
	if(task->suspend) return 1;

	/* Workϥɥ餬СƤӽФޤ
	 * Workϥɥ餬0֤顢ޤ
	 */
	if(task->work != NULL) {
		if(!task->work(task)) {
			task_free(task);
			return 0;
		}
	}

	/* ꥹȤƵŪ˸ƤӽФޤ */
	task_pos = task->children;
	while(task_pos != NULL) {
		/* task_work(task_pos)ƤӽФˤꡢ
		 * task_posϳǽΤǡ
		 * 餫ἡΥƤޤ
		 */
		task_next = task_pos->siblings;
		task_work(task_pos);
		task_pos = task_next;
	}

	return 1;
}

void
task_draw(TASK* task)
{
	TASK* task_pos;

	/* Drawϥɥ餬СƤӽФޤ */
	if(task->draw != NULL) task->draw(task);

	/* ꥹȤƵŪ˸ƤӽФޤ */
	task_pos = task->children;
	while(task_pos != NULL) {
		task_draw(task_pos);
		task_pos = task_pos->siblings;
	}
}

int
task_count(TASK* task)
{
	if(task == NULL) return 0;
	return 1 +				/* ʬ */
	       task_count(task->siblings) +	/*  */
	       task_count(task->children);	/* ¹ */
}
